; This is a 2-line kernel!
kernel
 lda bally
 sta stack2
 lda #1
 sta VDELBL
 sta VDELP0
 ldx missile1height
 inx
 sta WSYNC
 inx
 stx stack1
 ldx #0
 lda #4
 stx GRP0
 stx GRP1
 stx PF1
 stx PF2
 stx CXCLR
 sta temp4 ; pointer to PF gfx

 lda player0y ;store these so they can be retrieved later
 sta temp2
 lda player1y
 sta temp3

 lda missile0y
 sta temp5
 lda missile1y
 sta temp6

 lda playfieldpos
 sta temp1

 
 jmp .startkernel

.skipDrawP0
 sleep 2
 lda #0
 jmp .continueP0

.skipDrawP1
 sleep 2
 lda #0
 jmp .continueP1

.kerloop ; enter at cycle 59??
 
 ;missile/ball? 
 ldy playfield,x ;4
 sty PF1 ;3
 ldy playfield+1,x ;4
 sty PF2 ;3
 ldy playfield+3,x ;4
 sty PF1 ; 3 too early?
 ldy playfield+2,x;4
 sty PF2 ;3

; tya
goback
 dcp bally
; sleep 4

; sbc stack3
 rol
 rol
 sta ENABL 
.startkernel
 lda player0height ;3
 dcp player0y ;5
 bcc .skipDrawP0 ;2
 ldy player0y ;3
 lda (player0pointer),y ;5; player0pointer must be selected carefully by the compiler
			; so it doesn't cross a page boundary!

.continueP0
 sta GRP0 ;3
 lda missile0height ;3
 dcp missile0y ;5
; sbc stack1
 ;c=1 active
; ldy temp4 ;3;playfield counter
; lda #0 ;14
; lax temp4
; adc #1 ;16
 rol;2
 rol;2
 sta ENAM0 ;3


 ;missile/ball? 
 lda playfield,x ;4
 sta PF1 ;3
 lda playfield+1,x ;4
 sta PF2 ;3
 lda playfield+3,x ;4
 sta PF1 ; 3 too early?
 lda playfield+2,x;4
 sta PF2 ;3
 
 dec temp1
 beq altkernel
; sleep 3

 lda player1height
 dcp player1y
 bcc .skipDrawP1
 ldy player1y
 lda (player1pointer),y
.continueP1
 sta GRP1


 lda missile1height ;3
 dcp missile1y ;5
 sbc stack1
 ;c=1 active
; lax temp4 ;3
; lda #0 ;14
; adc #1 ;16
; rol;2
; rol;2
 sta ENAM1 ;3
 lda ballheight

; sleep 3
; lda ballheight
 jmp .kerloop

; sleep 2
; dex
; bne .kerloop

; beq endkernel

altkernel

 lda player1height
 dcp player1y
 bcc .skipDrawaltP1
 ldy player1y
 lda (player1pointer),y
.continuealtP1
 sta GRP1

 lda missile1height ;3
 dcp missile1y ;5
 ;c=1 active
; ldy temp4 ;3
; lda #0 ;14
; adc #1 ;16
 sbc stack1
 sta ENAM1 ;3

; sleep 2

 lda #0
 sta PF1
 sta PF2

 ;sleep 3

 ;28 cycles to fix things
 ;minus 11=17

; lax temp4
; clc
 txa
 adc #4
 tax
 cmp #44
 bne skiplastkernelline
 lda #9
 sbc playfieldpos
 sta temp4
 lda.w ballheight
 jmp enterlastkernel
skiplastkernelline

 sta temp4
 lda #8
 sta temp1
 lda ballheight

 jmp goback

 ;align 256

.skipDrawaltP1
 sleep 2
 lda #0
 jmp .continuealtP1

.skipDrawlastP0
 sleep 2
 lda #0
 jmp .continuelastP0

.endkerloop ; enter at cycle 59??
 
 ;missile/ball? 
 ldy playfield,x ;4
 sty PF1 ;3
 ldy playfield+1,x ;4
 sty PF2 ;3
 ldy playfield+3,x ;4
 sty PF1 ; 3 too early?
 ldy playfield+2,x;4
 sty PF2 ;3

enterlastkernel
; tya
 dcp bally
; sleep 4

; sbc stack3
 rol
 rol
 sta ENABL 
 lda player0height ;3
 dcp player0y ;5
 bcc .skipDrawlastP0 ;2
 ldy player0y ;3
 lda (player0pointer),y ;5; player0pointer must be selected carefully by the compiler
			; so it doesn't cross a page boundary!

.continuelastP0
 sta GRP0 ;3
 lda missile0height ;3
 dcp missile0y ;5
; sbc stack1
 ;c=1 active
; ldy temp4 ;3;playfield counter
; lda #0 ;14
; lax temp4
; adc #1 ;16

 dec temp4
 beq endkernel
; sleep 3


 ;missile/ball? 
 ldy playfield,x ;4
 sty PF1 ;3
 ldy playfield+1,x ;4
 sty PF2 ;3
 ldy playfield+3,x ;4
 sty PF1 ; 3 too early?
 ldy playfield+2,x;4
 sty PF2 ;3

 rol;2
 rol;2
 sta ENAM0 ;3
 

 lda player1height
 dcp player1y
 bcc .skipDrawlastP1
 ldy player1y
 lda (player1pointer),y
.continuelastP1
 sta GRP1


 lda missile1height ;3
 dcp missile1y ;5
 sbc stack1
 ;c=1 active
; lax temp4 ;3
; lda #0 ;14
; adc #1 ;16
; rol;2
; rol;2
 sta ENAM1 ;3
 lda ballheight

; sleep 3
; lda ballheight
 jmp .endkerloop


.skipDrawlastP1
 sleep 2
 lda #0
 jmp .continuelastP1


endkernel
 ; 6 digit score routine
 lda #0
 sta PF1
 sta PF2
 
                STA WSYNC ;first one, need one more
;                LDA #0
 sta REFP0
 sta REFP1
                STA GRP0
                STA GRP1
 ;               STA PF1
   ;             STA PF2
 sta ENAM0
 sta ENAM1
 sta ENABL
 sta WSYNC
 sleep 2
                STA GRP0
                STA GRP1 ; seems to be needed because of vdel

                LDY #7
                STY temp1
        LDA #$03
        STA NUSIZ0
        STA NUSIZ1
        STA VDELP0
        STA VDELP1
        LDA #$F0
        STA HMP0
               LDA scorecolor 
                nop
                STA RESP0
                STA RESP1
                STA COLUP0
                STA COLUP1
;               STA HMCLR
                STA WSYNC; second one
                STA HMOVE

loop2
 ldy  temp1        ;+3  63  189
 lda  (scorepointers),y     ;+5  68  204
 sta  GRP0            ;+3  71  213      D1     --      --     --
 sta  WSYNC           ;go
 lda  (scorepointers+$2),y  ;+5   5   15
 sta  GRP1            ;+3   8   24      D1     D1      D2     --
 lda  (scorepointers+$4),y  ;+5  13   39
 sta  GRP0            ;+3  16   48      D3     D1      D2     D2
 lda  (scorepointers+$6),y  ;+5  21   63
 sta  temp4         ;+3  24   72
 lda  (scorepointers+$8),y  ;+5  29   87
 tax                  ;+2  31   93
 lda  (scorepointers+$A),y  ;+5  36  108
 tay                  ;+2  38  114
 lda  temp4         ;+3  41  123              !
 sta  GRP1            ;+3  44  132      D3     D3      D4     D2!
 stx  GRP0            ;+3  47  141      D5     D3!     D4     D4
 sty  GRP1            ;+3  50  150      D5     D5      D6     D4!
 sta  GRP0            ;+3  53  159      D4*    D5!     D6     D6
 dec  temp1        ;+5  58  174                             !
 bpl  loop2           ;+2  60  180
 
                STA WSYNC       ;JUST ADDED
                LDA #0   
               STA GRP0
                STA GRP1
        STA VDELP0
        STA VDELP1;do we need these
        STA NUSIZ0
        STA NUSIZ1

 lda temp2 ;restore variables that were obliterated by kernel
 sta player0y
 lda temp3
 sta player1y
 lda temp5
 sta missile0y
 lda temp6
 sta missile1y
 lda stack2
 sta bally

 lda #43
 sta TIM64T
 LDA #%01000010
 sta WSYNC
 STA VBLANK
 rts
